' --------------------------------------------------------------------------------------------------
' DJ: Script that checks:  IP connectivity, Service status and sends email based on the results
' 0.1	March 24 2010	First try
' 
' HOW? Edit the parameters below. Set strDebug to 1 to test if ok, set to 0
'	    for silent operation and email sending. Schedule on different windows computer (every 15 minutes?).
'	    If the system cannot ping your MAIL server it won't send an email
' --------------------------------------------------------------------------------------------------

strHomeSeerIP     = "10.1.1.1" 
strServiceName    = "HomeSeerService"
strDebug          = 1   		' 1=On, displaying message boxes (emails will NOT be send!) , 0=Off for silent operation
strEmailTo        = "TO@email.com"
strEmailFrom      = """HomeSeer Status"" <FROM@email.com>"
strEmailSubject   = "HomeSeer STATUS"

strEmailSendUsing = 2		' 1=send using local SMTP service pickup directory,    2=send using SMTP over the network (using external email provider)
strEmailServer    = "mail.domain.com"
strEmailAuth      = 1		' 0=No authentication    1=Clear-text authentication    2=NTLM 
strEmailAccount   = "FROM@email.com"
strEmailPwd       = "password"
strEmailPort      = 25
strEmailUseSSL    = false
strEmailTimeOut   = 60
' -----------------------------------------------------------------end of parameters-------------------

strMessage = ""
' ============= Check IP Connectivity                      
If IsAlive(strHomeSeerIP) then
	' ============= Check Service Status
	If ServiceStatus(strHomeSeerIP,strServiceName) then
		strMessage = "Network=OK" & vbCRLF & strServiceName & "=running"
		If strDebug > 0 then Msgbox strMessage
	Else
		strMessage = "EMAIL SEND!" & vbCRLF & "Network=OK " & vbCRLF & strServiceName & "=NOT running!"
		If strDebug > 0 then MsgBox strMessage
		'============= SEND EMAIL "SERVICE NOT RUNNING!"
		If strDebug = 0 then SendMail(strMessage)		
	End If
Else
	strMessage = "EMAIL SEND!" & vbCRLF & "Network=PROBLEM!"
	If strDebug > 0 then MsgBox strMessage
	'============= SEND EMAIL "NETWORK PROBLEM"
	If strDebug = 0 then SendMail(strMessage)			
End if



' ============= Send EMAIL if there is a problem
'		IF no IP then email
'		IF IP and no Service then email
Sub SendMail(strBody)
	Set objMessage = CreateObject("CDO.Message")
	objMessage.Subject = strEmailSubject
	objMessage.From = strEmailFrom
	objMessage.To = strEmailTo
	objMessage.TextBody = strBody
	objMessage.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/sendusing") = strEmailSendUsing
	objMessage.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/smtpserver") = strEmailServer
	objMessage.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/smtpauthenticate") = strEmailAuth
	objMessage.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/sendusername") = strEmailAccount
	objMessage.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/sendpassword") = strEmailPwd
	objMessage.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/smtpserverport") = strEmailPort
	objMessage.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/smtpusessl") = strEmailUseSSL
	objMessage.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/smtpconnectiontimeout") = strEmailTimeOut
	objMessage.Configuration.Fields.Update
	If IsAlive(strEmailServer) then objMessage.Send
End Sub


' ============= Check Service Status        
Function ServiceStatus(strHost,strService)        
	Set objComputer = GetObject("WinNT://" & strHost & ",computer")
	Set objService = objComputer.GetObject("service", strService)  
	If objService.Status = 4 Then
		'Msgbox "2nd The " & strService & "service is running"
		ServiceStatus = true
	Else
		'MsgBox "2nd The " & strService & " service is NOT running!"
		ServiceStatus = false
	End If
End Function


'---------- Test to see if host or url alive through ping -----------------
Function IsAlive(strHost)
	Const OpenAsASCII = 0
	Const FailIfNotExist = 0
	Const ForReading =  1
	Dim objShell, objFSO, sTempFile, fFile
	Set objShell = CreateObject("WScript.Shell")
	Set objFSO = CreateObject("Scripting.FileSystemObject")
	sTempFile = objFSO.GetSpecialFolder(2).ShortPath & "\" & objFSO.GetTempName
	objShell.Run "%comspec% /c ping.exe -n 2 -w 500 " & strHost & ">" & sTempFile, 0 , True
	Set fFile = objFSO.OpenTextFile(sTempFile, ForReading, FailIfNotExist, OpenAsASCII)
	Select Case InStr(fFile.ReadAll, "TTL=")
		Case 0
			IsAlive = False
		Case Else
			IsAlive = True
	End Select
	fFile.Close
	objFSO.DeleteFile(sTempFile)
	Set objFSO = Nothing
	Set objShell = Nothing
End Function 
